#include "miccreatetemplate.h"
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "common.h"



MICcreateTemplate::MICcreateTemplate(QWidget *parent) :
    QMainWindow(parent)
{
}




//---------------------------------------------------------//
//
//---------------------------------------------------------//
void MainWindow::MICcreateTemplate()
{

    try
    {

        qDebug("MICcreateTemplate START [%s][%d]\n" , __FILE__, __LINE__ );

        double elvfrom    = 0; // 仰角開始
        double elvint     = 0; // 仰角間隔
        double elvto      = 0;
        int numelv        = 0; // 仰角数

        double heightfrom =0;  // 高さ開始
        double heightto   = 0 ;
        double heightint  = 0 ; // 高さ間隔


        double azifrom    = 0; //方位角
        double azito      = 0;
        double aziint     = 0;
		int numazi        = 0; //方位角数

        int numheight     = 0;  // 高さ数
        int result        = -1; // 戻り値
        int mic_cnt       = 0;

        QString channel_list = "0,1,2,3,4,5,6,7";


        //--------------------------------------------------------//
        // 球面座標 or 円柱座標 check
        //--------------------------------------------------------//
        int coordinate = 0;

        if (ui->mic_spherical->isChecked()) //球面座標?
        {
            coordinate = 0; //球面座標
        }
        else
        {
            coordinate = 1; //円柱座標
        }



        //--------------------------------------------------------//
        // radius(距離)
        //--------------------------------------------------------//
        double radius = ui->mic_radiusfrom->value();



        switch(coordinate)
        {
        //------------------------------------------------------------//
        //  球面座標                                                  //
        //------------------------------------------------------------//
        case 0:
            {
                //--------------------------------------------------------//
                // elevation(仰角)
                //--------------------------------------------------------//
                elvfrom = ui->mic_elvfrom->value(); // 仰角開始
                elvto   = ui->mic_elvto->value();   // 仰角終了
                elvint  = ui->mic_elvint->value();  // 仰角間隔

				numelv = CalcNumelv( elvfrom ,  elvto, elvint);

                break;
            }
        //------------------------------------------------------------//
        //  円柱座標                                                  //
        //------------------------------------------------------------//
        case 1:
            {
                //--------------------------------------------------------//
                // height(高さ)
                //--------------------------------------------------------//
                heightfrom = ui->mic_heightfrom->value(); // 高さ開始
                heightto   = ui->mic_heightto->value();
                heightint  = ui->mic_heightint->value(); // 高さ間隔

				numheight = CalcNumheight( heightfrom   // 高さ開始
							 	  		  , heightto    // 高さ終了
									      , heightint); // 高さ間隔

                break;
            }

        }//switch


        //--------------------------------------------------------//
        // AZIMUTH(方位角)
        //--------------------------------------------------------//
         azifrom = ui->mic_azifrom->value(); // 方位角開始
         azito   = ui->mic_azito->value();   // 方位角終了
         aziint = ui->mic_aziint->value();   //方位角間隔


		 numazi = CalcNumazi( azifrom,  azito,  aziint);


		mic_cnt = numazi;

        switch(coordinate)
        {
        //------------------------------------------------------------//
        //  球面座標                                                  //
        //------------------------------------------------------------//
        case 0:
            {
				if( numelv != 0 )
				{
					//方位角 X 仰角
					mic_cnt = numazi * numelv;
				}
				break;
			}
		case 1:
			{
				if( numheight != 0 )
				{
					//方位角 X 高さ数
					mic_cnt = numazi * numheight;
				}
				break;
			}
        }//switch



        if(ui->mic_mic_flg->isChecked() == true )
		{
		    channel_list        = ui->mic_mic_list->text();                  // チャンネルリスト
//		    QString use_channel_list    = (ui->mic_mic_flg->isChecked()? "" : "#");  // チャンネルリストチェックボックスON
		}
		else
		{
			for(int i = 8 ; i<mic_cnt ; i++)
			{
				 channel_list = channel_list + QString("%1%2").arg(",").arg(i);
			}	
		}





        qDebug("mic_cnt[%d]\n",mic_cnt);
        qDebug("channel_list[%s]\n", channel_list.toStdString().c_str());


        // 一時ディレクトリを生成
        boost::filesystem::path temp_dir = CreateTemporaryDirectory();
        boost::filesystem::path hark_config_file_path = temp_dir / "MicArrayLocationFile.xml";

        qDebug() << "hark_config_file_path.c_str() =" << hark_config_file_path.c_str() ;


        switch(coordinate)
        {
            //------------------------------------------------------------//
            //  球面座標(仰角)                                             //
            //------------------------------------------------------------//
            case 0:
            {
                // MicArrayLocationFileを作成
                result = ::system((boost::format("harktool4_cui "
                                                    "--mode template "
                                                    "--output-file %s "
                                                    "--nummic %d "
                                                    "--output-format xml "
                                                    "--output-type mic "
                                                    "--azifrom %f --aziint %f --numazi %d "
                                                    "--elvfrom %f --elvint %f --numelv %d "
                                                    "--radius %f "
                                                    "--mic-channels %s "
                                                    )
                                                    % hark_config_file_path
                                                    % mic_cnt
                                                    % azifrom % aziint % numazi
                                                    % elvfrom % elvint  % numelv
                                                    % radius
                                                    % channel_list.toStdString()).str().c_str()) ;


                qDebug((boost::format("harktool4_cui "
                                                    "--mode template "
                                                    "--output-file %s "
                                                    "--nummic %d "
                                                    "--output-format xml "
                                                    "--output-type mic "
                                                    "--azifrom %f --aziint %f --numazi %d "
                                                    "--elvfrom %f --elvint %f --numelv %d "
                                                    "--radius %f "
                                                    "--mic-channels %s "
                                                    )
                                                    % hark_config_file_path
                                                    % mic_cnt
                                                    % azifrom % aziint % numazi
                                                    % elvfrom % elvint  % numelv
                                                    % radius
                                                    % channel_list.toStdString()).str().c_str()) ;

                break;
            }
            //------------------------------------------------------------//
            //  円柱座標(高さ使用)                                         //
            //------------------------------------------------------------//
            case 1:
            {

                // MicArrayLocationFileを作成
                result = ::system((boost::format("harktool4_cui "
                                                    " --mode template "
                                                    "--output-file %s "
                                                    " --output-format xml "
                                                    " --nummic %d "
                                                    " --output-type mic "
                                                    " --azifrom %f --aziint %f --numazi %d "
                                                    " --heightfrom %f --heightint %f --numheight %d "
                                                    " --radius %f "
                                                    " --mic-channels %s "
                                                    )
                                                    % hark_config_file_path
                                                    % mic_cnt
                                                    % azifrom % aziint % numazi
                                                    % heightfrom % heightint % numheight
                                                    % radius
                                                    % channel_list.toStdString()).str().c_str()) ;

				
				// print
				qDebug((boost::format("harktool4_cui "
                                                    " --mode template "
                                                    "--output-file %s "
                                                    " --output-format xml "
                                                    " --nummic %d "
                                                    " --output-type mic "
                                                    " --azifrom %f --aziint %f --numazi %d "
                                                    " --heightfrom %f --heightint %f --numheight %d "
                                                    " --radius %f "
                                                    " --mic-channels %s "
                                                    )
                                                    % hark_config_file_path
                                                    % mic_cnt
                                                    % azifrom % aziint % numazi
                                                    % heightfrom % heightint % numheight
                                                    % radius
                                                    % channel_list.toStdString() ).str().c_str()  );

                break;
            }
        }//switch

        if (result != 0)
        {
            THROW_CRITICAL(trUtf8("harktool4_cuiコマンドを正常に実行できませんでした"));
            return;
        }


        //-----------------------------------------------------//
        //  xmlファイルを整形する
        //-----------------------------------------------------//
        ::system((boost::format("tidy -o %s -xml -utf8 -w 255 -c -q -asxml -i %s ")
                                % hark_config_file_path.c_str()
                                % hark_config_file_path.c_str()).str().c_str());




        QFile hark_config(hark_config_file_path.c_str());

        if (!hark_config.open(QIODevice::ReadOnly))
        {
            THROW_CRITICAL(trUtf8("作成したファイルを読み込めませんでした"));
        }

        QTextStream inbuf(&hark_config);
        QString outbuf = inbuf.readAll();
        qDebug() << outbuf;
        ui->mic_textEdit->setStyleSheet(" color: white;font: bold 16px;");
        ui->mic_textEdit->setText(outbuf);

        qDebug() << "harktool4_cui Ok" ;


        //-----------------------------------------------------------------//
        // hark_config_file_pathを格納する
        //-----------------------------------------------------------------//
//        m_plotctl[m_out_page_no].mic_hark_path = hark_config_file_path;

        //-----------------------------------------------------------------//
		// テンポラリ削除
        //-----------------------------------------------------------------//
		std::string temp = (boost::format("rm -rf %s") % temp_dir).str();
		::system(temp.c_str());
		m_plotctl[m_out_page_no].mic_hark_path = "";

        return;

    }
    catch (std::exception& exp)
    {
        THROW_CRITICAL(exp.what());
    }
    catch (...)
    {
        THROW_CRITICAL(trUtf8("unexpected error"));
    }


}
